﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMonorail.Entities;

/// <summary>
/// Класс-сущность "Монорельс"
/// </summary>
public class EntityMonorail : EntityTrain
{
    /// <summary>
    /// Количество колёс
    /// </summary>
    public int Wheels { get; private set; }

    /// <summary>
    /// Дополнительный цвет
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Признак наличия магнитного рельса
    /// </summary>
    public bool Rail { get; private set; }

    /// <summary>
    /// Признак наличия второго вагона 
    /// </summary>
    public bool SecondСarriage { get; private set; }

    /// <summary>
    /// Конструктор
    /// </summary>
    /// <param name="wheels">Количество колёс</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="rail">Признак наличия магнитного рельса</param>
    /// <param name="secondCarriage">Признак наличия второго вагона</param>
    public EntityMonorail(int speed, int weight, int wheels, Color mainColor, Color additionalColor, bool rail, bool secondCarriage) : base(speed, weight, mainColor)
    {
        Wheels = wheels;
        AdditionalColor = additionalColor;
        Rail = rail;
        SecondСarriage = secondCarriage;
    }
}
