﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMonorail.Entities;

/// <summary>
/// Класс-сущность "Поезд"
/// </summary>
public class EntityTrain
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color MainColor { get; private set; }

    /// <summary>
    /// Шаг передвижения
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Конструктор сущности
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="mainColor">Основной цвет</param>
    public EntityTrain(int speed, double weight, Color mainColor)
    {
        Speed = speed;
        Weight = weight;
        MainColor = mainColor;
    }
}
