﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMonorail.MovementStrategy;

public class MoveToBorder : AbstractStrategy
{
    protected override bool IsTargetDestination()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return false;
        }
        return objParams.RightBorder + GetStep() >= FieldWidth && objParams.DownBorder + GetStep() >= FieldHeight;
    }

    protected override void MoveToTarget()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return;
        }
        int diffx = objParams.RightBorder - FieldWidth;
        if (Math.Abs(diffx) > GetStep())
        {
            MoveRight();
        }
        int diffy = objParams.DownBorder - FieldHeight;
        if (Math.Abs(diffy) > GetStep())
        {
            MoveDown();
        }
    }
}
